#include "edt.h"

extern unsigned bufsize;
extern char *lb, *le;
extern changed, xmax;
extern char *nsl, *fsl;
extern char *al, *alp;
extern glc;

int fv;



void copy( t,f,n )
register char *t,*f;
register unsigned n;
{
  if( n==0 || (t==f) )
     return;
  if( t<f )
  {
     do
     {
        *t++ = *f++;
     } while(--n);
  }
  else
  {
     t+=n;
     f+=n;
     do
     {
        *--t = *--f;
     } while(--n);
  }
}


char * thline( l )
register char *l;
{
   while( *--l );
   return( l+1 );
}


char * nxtline(p)
register char *p;
{
  while( *p++ );
  return( p );
}


char * lstline(p)
register char *p;
{
  --p;
  if( !*(p-1) )  return p;
  while( *--p );
  return( p+1 );
}


pralnum()
{
 register n;
 register char *s;

  for( n=1,s=al ; s>lb ; n++ ) s=lstline(s);
  stc( xmax - 20, 2);
  type( "  Line %-4u Col %-5u", n, cntch( al, alp ) + 1 );
  return( n );
}


char * mkroom( register char * loc, int anz )
{
register char *f, *t;
char *n;
  if( anz<= 0 ) return(0);
  f=t=n= nxtline( loc );
  if( le+anz > lb+ bufsize ) return(0);
  if( anz ){ copy( n+anz, n, le-n ); }
  le+=anz;
  t+=anz;
  if( fsl > f ) fsl+=anz;
  if( nsl > f ) nsl+=anz;
  if( t<n+anz ) *t=0;
  while( f>loc ) *--t= *--f;
  changed= 1;
  return( t );
}


void delblk( f, t )
register char *f, *t;
{
register char *dummy;
int anz;

  if( f != t ) changed= 1;
  else return;
  if( t< f ){
    dummy= t;
    t= f;
    f= dummy;
  }
  while( (*f++ = *t++) != 0 );
  anz= t-f;
  if( fsl > f ) fsl-=anz;
  if( nsl > f ) nsl-=anz;
  le-= (int)t;
  copy( f, t, (unsigned)le );   /* ??? */
  le+= (int)f;
}



char * pfind( f )
char *f;
{
register char *s, *t, *p;
   p= alp;
   fv= 0;
   for(;;){
      s=p; t=f;
      while( *t==*s && *t ){ ++t; ++s; }
      if( *t==0 ) return( s );
      if( *p++== 0 ){
         if( p>= le ) break;
         ++fv;
      }
   }
   return( 0 );
}


char * mfind( char * f )
{
register char *p, *s, *t;
char *e;
   p= alp;
   fv= 0;
   e= f; while( *e ) ++e;
   for(;;){
      t=e;
      s=p;
      while( t>f ) if( *--t != *--s ) break;
      if( *t == *s ) return( s );
      if( *--p==0 ){
         if( p<= lb )break;
         if( *--p ) ++p;
         fv--;
      }
   }
   return( 0 );
}


