#include "edt.h"

extern char chbycurs, dodraw;
extern char *al, *alp, *als, *fsl, *le, *lb;
extern char *topline;
extern char ininame[];
extern int cnt, lstcom, indent;
extern int ymax, cursy, changed;
extern int w, h, cmac;
extern int tabs, ctrl, glc, alshifted, asking;
extern char * fmac;

static int rcnt;
char delbuf;

static char insstr[] = "INSERT: <curs> Ins - exchange";
static char xchstr[] = "EXCHANGE: <curs> Ins - insert";

static char ignstr[]= "--> ignore the changes ? ";

static char *setstr="SET: ^Q 1..9(Tabs=%d) Del_buf Indent";

static char *sl,*asl;
static int sv;
static char rstr[ FILENAMELEN ];
static char bstr[ FILENAMELEN ];

static char fstr[ FILENAMELEN ]= "";
extern int fv;
extern char *pfind();
extern char *mfind();



void insmenu( int i )
{
register char c;
register int v, gli;
register char *s, *t, *f;

  pralnum();
  cnt= 1;
  lstcom= 0;
  topstr( i ? insstr : xchstr );
  rstc();
  while( (c= getach()), !isesc(c) ){
    if( !cursmenu( c ) ) continue;
    lstcom= 0;
    if( chbycurs ) c = chbycurs;
    if( c== ('V'&077) ) {
      i= !i;
      topstr( i ? insstr : xchstr );
      rstc();
      continue;
    }
    if( c== ('Q'&077) ) c= getach();
    else if( c == '\r' ) c= 0;
    v= 1;
    if( c==0 ){
      if( indent ){
        s= al;
        while( *s==' ' || *s=='\t' ) ++s;
        v+= (s-al);
      }
    }
    if( i || c==0 || (*alp==0) ) if( !mkroom( alp,v ) ){
      message( "-->too many chars, can't insert%c", 7 );
      rstc();
      continue;
    }
    if( c==0 ){
      t= alp;
      if( indent ){
        t++;
        f= al;
        gli = cntch( f, s );
        while( f<s )
           *t++ = *f++;
      }
      else
         gli = 0;
      *alp= 0;
    }else{
      *alp= c;
      changed= 1;
    }
    if( !c )  als = 0;
    retypeal();
    if( !c ){
      leaveal();
      ++alp;
      if( cursy<(ymax-1) ) {
        scrdn( cursy+=1 , ymax );
      }
      else{
        if( cursy==ymax ) {
          scrup( 3,ymax ); fsl= nxtline( fsl );
        }
        cursy= ymax;
      }
      al= als= alp;
      pralnum();
      glc = gli;
      drawal();
      rstc();
    }
    else shcurs( 1 );
    cnsl();
  }
  topstr( topline );
}


qumenu()
{
  topstr("QUIT: Exit Update Write Init" );
  clrmsg();
  type( "--> '%s' %s %u", ininame,
           (changed? "*":""), le-lb);
  for( ;; ){
    rstc();
    switch( getach() ){
      case 'e':
      case 'E':
        if( changed ){ if( ansyn( ignstr, "" )) return( 0 );}
        else return( 0 );
        break;
      case 'i':
      case 'I':
        if( changed ) if( !ansyn( ignstr, "" ))break;
        initialize( anss( "--> file: " ) );
        return( 'i' );
      case 'u':
      case 'U':
        wrfile( ininame ); break;
      case 'w':
      case 'W':
        wrfile( anss( "-->WRITE  file: " )); break;
      case 033:
        return( ' ');
    }
  }
}


void setmenu()
{
register char c;

  clrl(1); type( setstr, tabs );
  clrmsg();
  c= getach();
  if( c== 'I' || c== 'i' ){
     if( ansyn( "Indent is %s. Change ? " , indent ? "on" : "off" ) )
        indent= !indent;
  }
  else if( c== 'D' || c== 'd' ){
     if( ansyn( "Del buffer is %s. Change ? " , delbuf ? "on" : "off" ) )
        delbuf= !delbuf;
  }
  else if( c== ('Q'&077) ) {
    ctrl= !ctrl;
    visual( fsl, 3 );
  }
  else if( isdigit(c) && c != '0' ) {
    tabs= c-'0';
    visual( fsl, 3 );
  }
  else  if(c != 033)  message( "--> bad set name%c", 7 );
  topstr( topline );
}


static void scurs( int r )
{
register int v;
register char *loc;
register char *dummy, *aloc;

  loc= alp;
  aloc= al;
  v= 0;
  if( r>0 ){
    do{
      if( *loc++ == 0 ) {
        dummy= loc;
        if( *loc == 0 ) ++loc;
        if( loc >= le ) { loc= dummy; break; }
        aloc= loc;
        v++;
      }
    }while( --r );
  }else {
    do{
      if( *--loc == 0 ) {
        if( loc <= lb ) { loc= lb; break; }
        if( *--loc ) ++loc;
        aloc= lstline( loc );
        v--;
      }
    }while( ++r );
  }
  rcnt= r;
  glc= cntch( aloc, loc );
  sl= loc;
  asl= aloc;
  sv= v;
}


void shcurs( int c )
{
  scurs( c );
  vl( sv, 0 );
}


void delch( c )
register int c;
{
register char *f;
register char *t;
register int l;
  if( c==0 ) return;
  f= t= alp;
  l=0;
  if( c>0 ) while( c-- > 0 ){
  if( *t++ == 0 ) {
      l++;
      if( t >= le ) { t=le-1; break; }
    }
  }
  else while( c++ < 0 ){
    if( t==lb ) break;
    if( *--t == 0 )
      l--;
  }
  bdel( f,t );
}


void bdel( f,t )
register char *f, *t;
{
register char *s, *n;
register int x;

   if( f==t ) return;
   if( f>t ){
      n=f;
      f=t;
      t=n;
   }
   s= thline( f );
   n= thline( t );
   if( s< al ){
      if( (x=wscdn( cursy-1, s )) != 0 )
         wscup( (cursy-=x)+1, nxtline(n) );
   }
   if( n> al ) {
      wscup( cursy+1, nxtline(n) );
   }
   delblk( f,t );
   if( s==n ){
      glc= cntch( al, f );
      drawal();
      if( !alshifted ) {
         retypeal();
      }
   } else {
      al= als= s;
      cmpal( cntch( s,f ) );
      dodraw = 1;
      drawal();
   }
   if( cursy== 3 ) fsl= al;
   rstc();
   cnsl();
}


static void vf( int v )
{
  glc= cntch( thline( alp ), alp );
  if( cursy+v <= ymax && cursy+v >= 3 ) vl( v, 0 );
  else {
    vl( 10-cursy, v-10+cursy );
  }
}


static char * xfind( int c, register char * s )
{
register char *f;
register int v;
register int rev;
  rev=0;
  if( c<0 ) {
    c= -c;
    rev++;
  }
  v= 0;
  while( c-- ) {
    if( !(f= rev? mfind(s) : pfind(s)) ) break;
    alp= f;
    v+= fv;
  }
  if( !f ){
      stype( " can't find" );
      fmac= 0;
      cmac= 0;
  }
  vf( v );
  return( f );
}


char * findmenu( int c )
{
   if( getdefstr( "find: ", fstr ) ) return( xfind( c, fstr ) );
      else return( (char *) -1L );
}


char * mfindmenu( int c )
{
   if( getdefstr( "reverse find: ", fstr ) ) return( xfind( -c, fstr ) );
      else return( (char *) -1L );
}


static void rep( int c, int a, char * r, char * b )
{
register int rl,bl,l,v,ac;
register char *f,*t,*s;

   rl= strlen( r );
   bl= strlen( b );
   l= bl- rl;
   v=0;
   while( c-- ){
      if( (f=pfind(r)) == 0 ){
         message( "can't find \"" ); tstr( r,0 ); stype( "\"" );
         break;
      }
      alp= f;
      v+= fv;
      if( a ){
         vf( v ); v=0;
         clrmsg();
         stype( "replace [Y|N|Q]?" ); rstc();
         do{ ac= getach() & 0x5F ;
          }while( ac!='Y' && ac!='N' && ac!='Q' );
         if( ac=='N' )continue;
         if( ac=='Q' )break;
      }
      f-= rl;
      if( l>0 ){
         if( !mkroom( f,l ) ){
               message( "-->too many chars, can't replace%c", 7 );
               rstc();
               break;
         }
      }
      else if( l<0 ) delblk( f, f-l );
      s= b;
      t= f;
      while( *s ) *t++= *s++;
      changed= 1;
      alp= f+bl;
      if( a ){
         cnsl();
         cmpal( cntch( al, alp ) );
         stc( 1,cursy );
         tstr( als,0 );
         rstc();
      }else{
         if( cursy+v <= ymax ){
            stc( 1, cursy+v );
            tstr( thline(alp), 0 );
         }
         if( c==0 ){
            cnsl();
            dodraw = 1;
            vf( v );
         }
      }
   }
   if( a ){
      clrmsg();
      rstc();
   }
}


void again( char c, int a )
{
register int i;
int x;
   i= a;
   switch( c )  {
      case '-': i= -a;
      case 'f':
      case 'F':
           message( i>0 ? "find \"" : "reverse find \"" );
           tstr( fstr, 0 );
           stype( "\"" ); xfind( i, fstr ); rstc(); break;
      case 'r':
      case 'R': message( "rep. \"" ); x = tstr( rstr, 8 );
           stype( "\" by \"" ); tstr( bstr, x+5 ); stype( "\"" );
           rstc();
           rep( a, asking | (c == 'R'), rstr, bstr );
           break;
   }
}


void repmenu( int c, int ask )
{
   if( getdefstr( " replace:", rstr ) )
      if( getdefstr( " with:", bstr ) )
         rep( c,ask, rstr, bstr );
}


