#include "edt.h"


extern int cursx, cursy;
extern char *topline;
extern char *fsl;
extern int xmax, ymax;
extern char agcom;
extern char delbuf;

char cpb[ CPSIZE ];
char *cpbe = cpb;

char *al;
char *als;
char *alp;
int alshifted;
int glc;
static int rgc;
char dodraw = 0;



cmpal(g)
register int g;
{
register char *s;

  glc=g;
  s=al;
  rgc=g=cntch( s, (alp= posinline(s,g)) );
  while( g>= (xmax-2) ){
    g= cntch( (s=posinline(s, ((xmax*7) >> 3) + 1 )), alp );
  }
  alshifted= (s!=als);
  als= s;
  cursx= g+1;
  return( alshifted );
}


void leaveal()
{
   dodraw |= (als != al);
}



void drawal()
{
  if( dodraw || cmpal( glc ) )
  {
    visual( fsl,3 );
    dodraw = 0;
  }
  pralnum();
  rstc();
}


void retypeal()
{
  tstr( alp, cursx-1 );
}


static char * move( char * f, char * t, char * d )
{
  while( f < t )
  {
    if( (*d++ = *f++) != 0 ) continue;
  }
  return d;
}


static int bufmem( char * f, char * t )
{
 register char *s;

   if( t< f){ s=f; f=t; t=s; }
   if( (unsigned)t-(unsigned)f >= sizeof cpb ){
      message( "can't buffer" );
      rstc();
      return( 0 );
   }
   cpbe = move( f, t, cpb);
   return( 1 );
}


void copymen()
{
   if( cpbe==cpb ) return;
   if( !mkroom( alp, cpbe-cpb ) ){
      message( "-->too many chars, can't copy%c", 7 );
      return;
   }
   move( cpb, cpbe, alp);
   visual( al, cursy );
}


void getmen()
{
   rdfile( anss( "--> get from: "), alp );
   visual( al, cursy );
}


void putmen()
{
register char *f, *t, c;

   f= alp;
   topstr( "PUT: <curs> Find -find  P" );
   clrmsg();
   rstc();
   while( ((c= getach()) & 0x5F) != 'P' )
   {
      if( isesc(c) )
      {
    topstr( topline );
    return;
      }
      if( c== 'F' || c== 'f' ) { findmenu( 1 ); agcom = c; rstc(); continue; }
      if( c== '-' ) { findmenu( -1 ); agcom = c; rstc(); continue; }
      cursmenu( c );
   }
   if( alp< f ){ t=f; f= alp; }
   else t= alp;
   ptfile( anss( "--> file: "), f, t );
   topstr( topline );
}


void bufmen()
{
register char *f,c;

   f=alp;
   topstr( "BUFFER: <curs> Find -find  B" );
   clrmsg();
   rstc();
   while( ((c= getach()) &0x5F) != 'B' )
   {
      if( isesc(c) ){ topstr( topline ); return; }
      if( c== 'F' || c== 'f' ){ findmenu( 1 ); agcom = c; rstc(); continue; }
      if( c== '-' ){ findmenu(-1 ); agcom = c; rstc(); continue; }
      cursmenu( c );
   }
   bufmem( f, alp );
   topstr( topline );
}


void delmenu()
{
register char *f;
register char c;

  f=alp;
  topstr("DELETE: <curs> Find -find  D" );
  rstc();
  while( ((c= getach()) & 0x5F) != 'D' ){
    if( isesc(c) ) break;
    if( c== 'F' || c== 'f' ) { findmenu( 1 ); agcom = c; rstc(); continue; }
    if( c== '-' ) { findmenu( -1 ); agcom = c; rstc(); continue; }
    cursmenu( c );
  }
  if( c== 'D' || c== 'd' ) if( !delbuf || bufmem( f,alp ) ) bdel( f, alp );
  topstr( topline );
}


