#include "edt.h"

extern char *ininame;
extern unsigned bufsize;

extern changed;
extern char *lb, *le;

static char lbuf[10240];

static FILE *inf;
static int lcnt;
static char *fpos;

static FILE *outf;



static int fget( char * buf, int  num, FILE * fil )
{
 register l;
 char *b;

  b=fgets(buf,num,fil);
  if( b==NULL )
     return -1;
  l = strlen(b);
  if( *(buf+l-1) == '\n' )
  {
     l--;
     *(buf+l) = '\0';
  }
  return(l);
}


static void fputss( char * str, FILE * fil )
{
   fputs(str,fil);
   fputc('\n',fil);
}


static int rdline( void )
{
int llen;
char *f,*t;

  if( feof( inf ) ) return( 0 );
  llen= fget( lbuf, sizeof lbuf - 2, inf );
  if( llen == -1 )
    return 0;
  lcnt++;
  if( lbuf[llen-1] == '\r' )
     llen--;
  lbuf[ llen++ ] = 0;
  if( (le + llen) > lb+ bufsize ) {
    message( "--> buffer overflow (%u)%c", bufsize, 7);
    return( -1 );
  }
  f= fpos;
  fpos+= llen;
  t = fpos;
  le+= llen;
  copy( t, f, le-t );
  copy( f, lbuf, llen );
  return( llen );
}


rdfile( fn, pos )
char *fn;
char *pos;
{
int r;

  if( (inf=fopen( fn, "rbn" )) == NULL ) {
    message("--> can't open '%s'" , fn );
    return( 1 );
  }
  message( "--> reading '%s'", fn );
  lcnt= 0;
  fpos= pos;
  while( (r = rdline()) > 0 );
  fclose( inf );
  changed= 1;
  return( r );
}


static int wrline( char * l )
{
   fputss( l, outf );
   return( 0 );
}


ptfile( fn, s, e )
char *fn, *s, *e;
{
int i,c;
   if((outf=fopen(fn, "w"))==NULL) {
     message( "--> can't open '%s'", fn );
     return( 1 );
   }
   c= *e;
   *e=0;
   message( "--> writing to '%s'", fn );
   lcnt= 0;
   i= 0;
   while( s < e ) {
     if( wrline( s ) )
     {
        i++;
        /* i= ferror( outf ); */
        break;
     }
     s= nxtline( s );
   }
   clrmsg();
   *e= c;
   fclose( outf );
   return( i );
}


void wrfile( char * fn )
{
  if( !ptfile( fn, lb, le) ) changed= 0;
}


